#################################################################################
# idle_conf.pl
#
# Entman idlescript configuration for perl scripts
#
# Copyright (c) 2002 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
#
################################################################################

# the following is over rided by entman_global_config.pl with the tech_staff trigger.
$login_reset_cups_to_defaults_switch = 1;

$login_erase_print_queue_files_switch = 1;


# The following files will be duplicated after maintenance, stored in a private location
# (writable_caches_folder) and at login, they will be restored to their original location.
# This is to make sure that world writable files are always in an unmodified state at login.
# These files are automatically added to the world writable ignore list.

$nutdate1 = "/Applications/Now Up-to-Date & Contact 4.2.6/Now Contact 4.2.6/";
$nutdate1 .= "Now Contact 4.2.6 \302\247.app/Contents/MacOS/About Box Extras";
$nutdate2 = "/Applications/Now Up-to-Date & Contact 4.2.6/Now Up-to-Date 4.2.6/";
$nutdate2 .= "Now Up-to-Date 4.2.6 \302\247.app/Contents/MacOS/About Box Extras";
$fmp_stupid_file = "/Applications/FileMaker Pro 7.0v1a/";
$fmp_stupid_file .= "FileMaker Pro 7.0v1a \302\247.app/Contents/MacOS/pInfo";

$garage_band_file = "/Library/Audio/Apple Loops Index/Search Index ";
$garage_band_file .= "95F508B8-5A03-11D9-89CF-000A95BAB3B6.txt",
$logic_file = "/Library/Audio/Apple Loops Index/Search Index ";
$logic_file .= "A39507F6-50B0-11D9-961A-000A95BAB3B6.txt",


@login_replicate_items =     (
							   $nutdate1,
							   $nutdate2,
							   $fmp_stupid_file,
							   $garage_band_file,
							   $logic_file,
							   "/Library/Application Support/Adobe/Adobe Registration Database",
							   "/Library/Application Support/Adobe/SING/Datastore/SINGmeta.dat",
							   "/Library/Application Support/PRIF230451",
							   "/Library/Preferences/EverSmartDb.JazzPlus",
							 );

1;
