#!/usr/bin/perl

################################################################################
# Copyright (c) 2008 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

$location_of_ncutil = "/usr/sbin/ncutil"; # version 3.1.2

################################################################################
# Set Proxy Settings
if ( -e $location_of_ncutil ) {
  entman_logger ( "log drawer", "Setting proxy settings." );
  set_proxy_settings();
} else {
  entman_logger ( "log drawer", "ERROR: $location_of_ncutil is missing." );
}

sub set_proxy_settings {
  print "Updating Proxy Server settings\n";
  system "\"$location_of_ncutil\" setprop \"/Automatic/Built-in Ethernet/Proxies\" passive-ftp \"$postm_ftp_passive\"";
  if ( $postm_http_proxy_settings{'enable'} ) {
    system "\"$location_of_ncutil\" setprop \"/Automatic/Built-in Ethernet/Proxies\" http-proxy-enable \"$postm_http_proxy_settings{'enable'}\"";
    system "\"$location_of_ncutil\" setprop \"/Automatic/Built-in Ethernet/Proxies\" http-proxy-host \"$postm_http_proxy_settings{'host'}\"";
    system "\"$location_of_ncutil\" setprop \"/Automatic/Built-in Ethernet/Proxies\" http-proxy-port \"$postm_http_proxy_settings{'port'}\"";
  } else {
    system "\"$location_of_ncutil\" destroyprop \"/Automatic/Built-in Ethernet/Proxies\" http-proxy-enable";
    system "\"$location_of_ncutil\" destroyprop \"/Automatic/Built-in Ethernet/Proxies\" http-proxy-host";
    system "\"$location_of_ncutil\" destroyprop \"/Automatic/Built-in Ethernet/Proxies\" http-proxy-port";
  }
  if ( $postm_https_proxy_settings{'enable'} ) {
    system "\"$location_of_ncutil\" setprop \"/Automatic/Built-in Ethernet/Proxies\" https-proxy-enable \"$postm_https_proxy_settings{'enable'}\"";
    system "\"$location_of_ncutil\" setprop \"/Automatic/Built-in Ethernet/Proxies\" https-proxy-host \"$postm_https_proxy_settings{'host'}\"";
    system "\"$location_of_ncutil\" setprop \"/Automatic/Built-in Ethernet/Proxies\" https-proxy-port \"$postm_https_proxy_settings{'port'}\"";
  } else {
    system "\"$location_of_ncutil\" destroyprop \"/Automatic/Built-in Ethernet/Proxies\" https-proxy-enable";
    system "\"$location_of_ncutil\" destroyprop \"/Automatic/Built-in Ethernet/Proxies\" https-proxy-host";
    system "\"$location_of_ncutil\" destroyprop \"/Automatic/Built-in Ethernet/Proxies\" https-proxy-port";
  }
  if ( $postm_ftp_proxy_settings{'enable'} ) {
    system "\"$location_of_ncutil\" setprop \"/Automatic/Built-in Ethernet/Proxies\" ftp-proxy-enable \"$postm_ftp_proxy_settings{'enable'}\"";
    system "\"$location_of_ncutil\" setprop \"/Automatic/Built-in Ethernet/Proxies\" ftp-proxy-host \"$postm_ftp_proxy_settings{'host'}\"";
    system "\"$location_of_ncutil\" setprop \"/Automatic/Built-in Ethernet/Proxies\" ftp-proxy-port \"$postm_ftp_proxy_settings{'port'}\"";
  } else {
    system "\"$location_of_ncutil\" destroyprop \"/Automatic/Built-in Ethernet/Proxies\" ftp-proxy-enable";
    system "\"$location_of_ncutil\" destroyprop \"/Automatic/Built-in Ethernet/Proxies\" ftp-proxy-host";
    system "\"$location_of_ncutil\" destroyprop \"/Automatic/Built-in Ethernet/Proxies\" ftp-proxy-port";
  }
  if ( $postm_rtsp_proxy_settings{'enable'} ) {
    system "\"$location_of_ncutil\" setprop \"/Automatic/Built-in Ethernet/Proxies\" rtsp-proxy-enable \"$postm_rtsp_proxy_settings{'enable'}\"";
    system "\"$location_of_ncutil\" setprop \"/Automatic/Built-in Ethernet/Proxies\" rtsp-proxy-host \"$postm_rtsp_proxy_settings{'host'}\"";
    system "\"$location_of_ncutil\" setprop \"/Automatic/Built-in Ethernet/Proxies\" rtsp-proxy-port \"$postm_rtsp_proxy_settings{'port'}\"";
  } else {
    system "\"$location_of_ncutil\" destroyprop \"/Automatic/Built-in Ethernet/Proxies\" rtsp-proxy-enable";
    system "\"$location_of_ncutil\" destroyprop \"/Automatic/Built-in Ethernet/Proxies\" rtsp-proxy-host";
    system "\"$location_of_ncutil\" destroyprop \"/Automatic/Built-in Ethernet/Proxies\" rtsp-proxy-port";
  }
  if ( $postm_gopher_proxy_settings{'enable'} ) {
    system "\"$location_of_ncutil\" setprop \"/Automatic/Built-in Ethernet/Proxies\" gopher-proxy-enable \"$postm_gopher_proxy_settings{'enable'}\"";
    system "\"$location_of_ncutil\" setprop \"/Automatic/Built-in Ethernet/Proxies\" gopher-proxy-host \"$postm_gopher_proxy_settings{'host'}\"";
    system "\"$location_of_ncutil\" setprop \"/Automatic/Built-in Ethernet/Proxies\" gopher-proxy-port \"$postm_gopher_proxy_settings{'port'}\"";
  } else {
    system "\"$location_of_ncutil\" destroyprop \"/Automatic/Built-in Ethernet/Proxies\" gopher-proxy-enable";
    system "\"$location_of_ncutil\" destroyprop \"/Automatic/Built-in Ethernet/Proxies\" gopher-proxy-host";
    system "\"$location_of_ncutil\" destroyprop \"/Automatic/Built-in Ethernet/Proxies\" gopher-proxy-port";
  }
  if ( $postm_SOCKS_proxy_settings{'enable'} ) {
    system "\"$location_of_ncutil\" setprop \"/Automatic/Built-in Ethernet/Proxies\" SOCKS-proxy-enable \"$postm_SOCKS_proxy_settings{'enable'}\"";
    system "\"$location_of_ncutil\" setprop \"/Automatic/Built-in Ethernet/Proxies\" SOCKS-proxy-host \"$postm_SOCKS_proxy_settings{'host'}\"";
    system "\"$location_of_ncutil\" setprop \"/Automatic/Built-in Ethernet/Proxies\" SOCKS-proxy-port \"$postm_SOCKS_proxy_settings{'port'}\"";
  } else {
    system "\"$location_of_ncutil\" destroyprop \"/Automatic/Built-in Ethernet/Proxies\" SOCKS-proxy-enable";
    system "\"$location_of_ncutil\" destroyprop \"/Automatic/Built-in Ethernet/Proxies\" SOCKS-proxy-host";
    system "\"$location_of_ncutil\" destroyprop \"/Automatic/Built-in Ethernet/Proxies\" SOCKS-proxy-port";
  }
  if ( $#postm_host_exceptions >= 0 ) {
    system "\"$location_of_ncutil\" setprop \"/Automatic/Built-in Ethernet/Proxies\" host-exceptions @postm_host_exceptions\n";
  } else {
    system "\"$location_of_ncutil\" destroyprop \"/Automatic/Built-in Ethernet/Proxies\" host-exceptions";
  }
  system "\"$location_of_ncutil\" --apply-on-exit read \"/Automatic/Built-in Ethernet/Proxies\"";
}
