#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

# This script notifies you as many ways as possible that it is running.
#
# To get this to work, create a link to this script in the hooks folder, like this:
#
# For startup early hooks:
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/SEE_1_debug.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/SEE_2_debug.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/SED_debug1.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/SED_debug2.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/SEL_1_debug.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/SEL_2_debug.pl

# For startup late hooks:
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/SLE_1_debug.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/SLE_2_debug.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/SLD_debug1.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/SLD_debug2.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/SLL_1_debug.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/SLL_2_debug.pl

# For login hooks:
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/LIE_1_debug.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/LIE_2_debug.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/LID_debug1.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/LID_debug2.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/LIL_1_debug.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/LIL_2_debug.pl

# For logout hooks:
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/LOE_1_debug.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/LOE_2_debug.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/LOD_debug1.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/LOD_debug2.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/LOL_1_debug.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/LOL_2_debug.pl

# For postmaintenance hooks (these don't run unless the radmind module is used):
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/PME_1_debug.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/PME_2_debug.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/PMD_debug1.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/PMD_debug2.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/PML_1_debug.pl
# ln -s /Library/Xhooks/Modules/debug/bin/basic_debug.pl /Library/Xhooks/Modules/xhooks/hooks/PML_2_debug.pl

my $now = localtime(time);

# System Log
entman_logger ( "log drawer", "$now: $0 - @ARGV" );

# BigHonkingText
system "/usr/local/bin/BigHonkingText", "-p", "4", "-d", "-H", "$now: $0 - @ARGV";

# Speak
system "say", "Script running $0";

# Sounds
my $qtplay = "/usr/local/bin/qtplay";
my $dir_to_search = "/Library/Xhooks/Modules/edu.utah.scl.debug/sounds";

if ( $0 =~ /^LI/ ) {
  $dir_to_search .= "login/";
} elsif ( $0 =~ /^LO/ ) {
  $dir_to_search .= "logout/";
} elsif ( $0 =~ /^SE/ ) {
  $dir_to_search .= "startup/";
} elsif ( $0 =~ /^SL/ ) {
  $dir_to_search .= "startup/";
} elsif ( $0 =~ /^PM/ ) {
  $dir_to_search .= "postmaintenance/";
}

my @sounddir = get_rand_items_in_folder( $dir_to_search, 1 );
my $command = "";
foreach my $ii ( @sounddir ) {
  $command .= "\"$qtplay\" \"$ii\" && ";
}
$command = substr ( $command, 0, -2 );
if ( $command ne "" ) {
#  system $command;
}

# Email

print "echo '$now: $0 - @ARGV' | /usr/bin/mail -s '$0 ran' root\n";
system "echo '$now: $0 - @ARGV' | /usr/bin/mail -s '$0 ran' root";

exit 0;
