#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

$updateByHostPrefs_script = "/Library/Xhooks/Modules/edu.utah.scl.home_folder/updateByHostPrefs.sh";

################################################################################
# Fix the ByHost folder

wait_for_network();

updateByHost( "/Users/$adminusername/Library/Preferences/ByHost" );

updateByHost( "/var/root/Library/Preferences/ByHost" );

updateByHost( "$template_homefolder/Library/Preferences/ByHost" );

entman_logger ( "log drawer", "ByHost preferences fixed." );

exit 0;

sub updateByHost {
  # This subroutine is to handle spaces in folder names (which updateByHostPrefs script doesn't do)
  my ( $folder ) = @_;

  if ( ! -d $folder ) {
    entman_logger ( "log drawer", "The folder $folder does not exist." );
    return;
  }

  if ( grep / /, $folder ) {
    # spaces wont work in this script!

    my $temp_folder = "/Library/Preferences/Xhooks/ByHost";

    # Remove temp folder if it is there already
    if ( -e $temp_folder ) {
      entman_logger ( "log drawer", "The folder $temp_folder already exists.  Will erase (may cause trouble...)" );
      system "/usr/bin/chflags -R nouchg \"$temp_folder\"";
      system "/bin/rm -rf \"$temp_folder\"";
    }

    # Copy real folder to temp
    system "/usr/bin/ditto -rsrc \"$folder\" \"$temp_folder\"";
  
    # Fix prefs
    system "\"$updateByHostPrefs_script\" $temp_folder";
  
    # Erase old files
    system "/bin/rm \"$folder\"/* \"$folder\"/.*";

    # Move files back to real location
    system "/usr/bin/ditto -rsrc \"$temp_folder\" \"$folder\"";
  
    # Delete temp folder
    system "/usr/bin/chflags -R nouchg \"$temp_folder\"";
    system "/bin/rm -rf \"$temp_folder\"";
  
  } else {

    system "\"$updateByHostPrefs_script\" $folder";

  }

}

