#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

$create_cached_home_folders_script = "/Library/Xhooks/Modules/edu.utah.scl.home_folder/create_cached_home_folders.pl";

################################################################################
# Change guest permissions
#
if ( ! $template_name ) {
  $template_name = $adminusername;
}

system "/usr/sbin/chown -R \"$template_name\" \"$template_homefolder\"";
system "/usr/bin/chgrp -R \"$enduser_group\" \"$template_homefolder\"";
system "/usr/bin/chgrp admin \"$template_homefolder\"";
system "/bin/chmod -R g=u \"$template_homefolder\"";
system "/bin/chmod -R o-rwx \"$template_homefolder\"";

entman_logger ( "log drawer", "$template_homefolder permissions changed to $adminusername:$enduser_group g=u o-rwx." );

################################################################################
# Create transcript of folder for cleanup purposes.
#

$template_homefolder_files = "/Library/Preferences/Xhooks/Caches/edu.utah.scl.home_folder/home_folder_files";
$template_homefolder_transcript = "/Library/Preferences/Xhooks/Caches/edu.utah.scl.home_folder/entman_template_home_folder.T";

$delete_these_files = "";
system "cd \"$template_homefolder\"; /usr/local/bin/fsdiff -K /dev/null -c sha1 -C ./ > $template_homefolder_transcript";
if ( open FILE, "< $template_homefolder_transcript" ) {
  while ( <FILE> ) {
    my %radmind_line = parse_radmind_line($_);
    if ( defined $radmind_line{'path'} and $radmind_line{'filetype'} ne "d" ) {
      $delete_these_files .= "$radmind_line{'path'} $radmind_line{'checksum'}\n" # Leave a space in there even if there is no checksum (it is needed later)
    }
  }
  close FILE;

  if ( open FILE2, "> $template_homefolder_files" ) {
    print FILE2 $delete_these_files;
    close FILE2;
  } else {
    entman_logger ( "Could not save $template_homefolder_files: $!" );
  }

} else {
  entman_logger ( "Could not open $template_homefolder_transcript: $!" );
}


################################################################################
# Create cached home folders
#
my $number_of_folders_to_create = 1;

if ( defined $AUTO_LONG_MAINTENANCE_HOURS ) {
  if ( $AUTO_LONG_MAINTENANCE_HOURS =~ /(\d+) (\d+)/ ) {
    if ( timewindow( $1, $2 ) ) {
      $number_of_folders_to_create = 10;
    }
  }
}

system "\"$create_cached_home_folders_script\" $number_of_folders_to_create";
