#!/usr/bin/perl

################################################################################
# Copyright (c) 2008 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";
require "edu.utah.scl.availability/availability_lib.pl";

$idle_delay = 240;

$needsMoreHomeFolders = 1;
$trashNeedsCleaning = 1;
$i_reported_my_status = 0;
$loginwindow = "/System/Library/CoreServices/loginwindow.app/Contents/MacOS/loginwindow";
$create_cached_home_folders_script = "/Library/Xhooks/Modules/edu.utah.scl.home_folder/create_cached_home_folders.pl";

# Report that this computer is available
if ( defined $AVAILABILITY_URL and $AVAILABILITY_URL ne "" and ! $i_reported_my_status ) {
  report_availability ( "available", "" );
  $i_reported_my_status = 1;
}

while ( 1 ) {
  if ( idleTime() > $idle_delay ) {
    home_folder_management();
    if ( $trashNeedsCleaning ) {
      empty_trash();
      $trashNeedsCleaning = 0;
    }
    sleep 10;
  } else {
    my $pause_time = $idle_delay - idleTime() + 1;
    $pause_time = ( $pause_time > 0 ) ? $pause_time : 0;
    sleep $pause_time - idleTime() + 1;
  }
}

sub home_folder_management {
  # Ideally make this detached process (I believe it isn't currently)
  if ( $needsMoreHomeFolders ) {
	$currentHomeFolders = count_home_folder_cache_folders();
	if ( $currentHomeFolders < 10 ) {
	  say( "creating home folder" );
	  $currentHomeFoldersPlus1 = $currentHomeFolders + 1;
	  system "\"$create_cached_home_folders_script\" $currentHomeFoldersPlus1";
	} else {
	  $needsMoreHomeFolders = 0;
	}
  }
}

sub idleTime {
  foreach (`/usr/sbin/ioreg -c IOHIDSystem`) {
    if( /HIDIdleTime" = (\d*)/ ) {
      return $1/1000000000 if $1 ne "";
    }
  }
  return 0; # just in case
}
