#!/usr/bin/perl

################################################################################
# Copyright (c) 2008 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

if ( -f "/Library/Preferences/Xhooks/edu.utah.scl.radmind_xhooks_conf.perl" ) {
  use lib "/Library/Preferences/Xhooks";
  require "edu.utah.scl.radmind_xhooks_conf.perl";
}

if ( ! defined $HOMEPAGE or $HOMEPAGE eq "" ) {
	die "ERROR $0 - The variable HOMEPAGE is not defined.\n";
}

if ( ! defined $TEMPLATE_HOME_DIR or $TEMPLATE_HOME_DIR eq "" ) {
	die "ERROR $0 - The variable TEMPLATE_HOME_DIR is not defined.\n";
}

if ( ! -d $TEMPLATE_HOME_DIR ) {
	die "ERROR $0 - $TEMPLATE_HOME_DIR does not exist or is not a directory.\n";
}

##################################################################
# Save Firefox prefs

my $firefox_profiles = "$TEMPLATE_HOME_DIR/Library/Application Support/Firefox/Profiles";

if ( -d $firefox_profiles ) {
	opendir (DIR, "$firefox_profiles");
	while ($dir = readdir(DIR)){
		if ( $dir ne '..' and $dir ne '.' ) {
			my $firefox_prefs = "$firefox_profiles/$dir/prefs.js";
			if ( -e $firefox_prefs ) {
				my @lines;
				if ( open FF_PREFS, "<", $firefox_prefs ) {
					@lines = <FF_PREFS>;
					close FF_PREFS;
				} else {
					print "ERROR $0 - Could not read $firefox_prefs.\n";
				}
				foreach ( @lines ) {
					if( /user_pref\("browser.startup.homepage",/ ) {
						$_ = "user_pref(\"browser.startup.homepage\", \"$HOMEPAGE\");\n";
					}
				}
				if ( open FF_PREFS, ">", $firefox_prefs ) {
					print FF_PREFS @lines;
					close FF_PREFS;
				} else {
					print "ERROR $0 - Could not write ${firefox_prefs}.\n";
				}	
			}
		}
	}
	closedir (DIR);
} else {
	print "ERROR $0 - $firefox_profiles does not exist.\n"
}

##################################################################
# Save Safari prefs
system "defaults write '$TEMPLATE_HOME_DIR/Library/Preferences/com.apple.internetconfigpriv' WWWHomePage '$HOMEPAGE'" or print "ERROR $0 - Could not write to $TEMPLATE_HOME_DIR/Library/Preferences/com.apple.internetconfigpriv.plist\n";

exit 0;
