#!/bin/sh
#
# updateByHostPrefs - Update ByHost preference filenames with local MAC address.
#
# Copyright (c) 2002-2003 Occam's Razor. All rights reserved.
#
# See the LICENSE file distributed with this code for restrictions on its use
# and further distribution.
# Original distribution available at <http://www.occam.com/tools/>.
#
# $Id: updateByHostPrefs.sh,v 1.1.1.1 2004/10/16 19:20:12 jamesreynolds Exp $
#
# TODO
#	verify that the lookupd query to determine home dir works for all cases
#

PATH=/sbin:/bin:/usr/sbin:/usr/bin

updateFilenames () {
	# Don't split on whitespace, allowing for spaces in filenames.
	IFS="
"
	# old version: for file in `ls $byHostDir/*.plist $byHostDir/.*.plist`; do

    # SCL University of Utah mod #2:
	# All this extra code makes sure prefs with similar names (but diff ethernet) work.
	# So out of a list of similarly named files, the file that was modified last is the
	# one that is used.
	mkdir "$byHostDir/temp"
	cd "$byHostDir"
	for file in `ls -tr1 *.plist .*.plist 2> /dev/null`; do
		# Replace component of filename prior to ".plist" with MAC addr.
		newFile=`echo "$file" | sed "s/\.[^.]*\.plist/.$macAddr.plist/"`
		#[ -f "$newFile" ] || 
		mv "$file" "$byHostDir/temp/$newFile"
	done
	cd temp
	mv `ls -A` ".."
	cd ..
	rmdir "$byHostDir/temp"
}

cleanup () {
	status=$1
	exit $status
}

# SCL University of Utah mod (got rid fo setup func in order to handle spaces)

# Get "primary" MAC address listed by ifconfig.
macAddr=`ifconfig en0 | grep ether | cut -d" " -f2`
macAddr=`echo $macAddr | sed s/://g`
byHostDir="$1"

if [ "$byHostDir" = "" -o ! -e "$byHostDir" ]; then
	echo "Can't find $byHostDir"
	echo "Usage: $0 <path to byhostdir>"
	exit
fi

logger -t updateByHostPrefs -p user.info \
	"Updating for $byHostDir with a MAC address of $macAddr"
updateFilenames
cleanup 0
