#!/usr/bin/perl

################################################################################
# Copyright (c) 2008 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

if ( -f "/Library/Preferences/Xhooks/edu.utah.scl.radmind_xhooks_conf.perl" ) {
	use lib "/Library/Preferences/Xhooks";
	require "edu.utah.scl.radmind_xhooks_conf.perl";
} else {
	die "ERROR $0 - The file /Library/Preferences/Xhooks/edu.utah.scl.radmind_xhooks_conf.perl is missing and this script requires it!\n";
}

my $run_maintenance_loggout_trigger = "/tmp/launch_maintenance";
my $launch_maintenance_script = "/Library/Xhooks/Modules/edu.utah.scl.radmind/launch_maintenance";

if ( -e $run_maintenance_loggout_trigger ) {
	if ( defined $RADMIND_SERVERS[0] and $RADMIND_SERVERS[0] ne "" ) {
		print "$0 - $launch_maintenance_script" if ( defined $ENV{'xhooks_verbose'} and $ENV{'xhooks_verbose'});
		system "$launch_maintenance_script";
	} else {
		print "ERROR $0 - The radmind user ($RADMIND_USER_NAME) logged in but the variable \$RADMIND_SERVERS[0] is not defined, so I can't run radmind.  Rebooting.\n";
	}
}

exit 0;
