#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";
use lib "/Library/Preferences/Xhooks/";
require "replicate/replicate_conf.pl";

################################################################################
# entman - modules/configure/LID_replicate.pl
#
# This script copies files and folders that need to be replaced at every login
# from a backup.  Namely, cups settings, and files and folders that must be world
# world writable.  See PMD_replicate.pl for the half that creates the backup.
#
################################################################################

# Replicate world writable files (thx PSU for the name ;)

$backup_cups_folder = "/Library/Preferences/Xhooks/replicate";

if ( $postm_backup_world_writable_switch ) {

  foreach $file_to_replicate ( @login_replicate_items ) {

    #print `date`;

    if ( -e "$writable_caches_folder/$file_to_replicate" ) {
      if ( -e $file_to_replicate ) {

        #print "/usr/bin/chflags -R nouchg \"$file_to_replicate\"\n";
        system "/usr/bin/chflags -R nouchg \"$file_to_replicate\"";
        #print "/bin/rm -f \"$file_to_replicate\"\n";
        system "/bin/rm -f \"$file_to_replicate\"";

      }

      #print "/usr/bin/ditto -rsrc \"$writable_caches_folder/$file_to_replicate\" \"$file_to_replicate\"\n";
      system "/usr/bin/ditto -rsrc \"$writable_caches_folder/$file_to_replicate\" \"$file_to_replicate\"";
    }
  }
}

# Reset printers
if ( $login_reset_cups_to_defaults_switch ) {

  # Erase print queue files
  if ( $login_erase_print_queue_files_switch ) {
    for ( `/usr/bin/lpstat -a` ) {
      s/\s.*\n//;
      #print "$_\n";
      `/usr/bin/cancel -a "$_"`;
    }
  }

  if ( -e "$backup_cups_folder/ppd" ) {

    system "/bin/rm -fr /etc/cups/ppd";
    system "/bin/rm -f /etc/cups/printers.conf";
    system "/usr/bin/ditto \"$backup_cups_folder/ppd\" /etc/cups/ppd";
    system "/usr/bin/ditto \"$backup_cups_folder/printers.conf\" /etc/cups/printers.conf";

    system "/usr/bin/killall -HUP cupsd";
    if ( ! isThisAppRunning( "cupsd", "root" ) ) {
      system "/usr/sbin/cupsd";
    }

  }    

}

exit 0;
