#!/usr/bin/perl

################################################################################
# Copyright (c) 2008 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use Getopt::Std;

use lib "/Library/Xhooks/Modules";
require "xhooks/lib/config.pl";

################################################################################
# Send Email

if ( defined $REPORT_EMAIL_SERVER and $REPORT_EMAIL_SERVER ne "" and
     defined $REPORT_EMAIL_ACCOUNT and $REPORT_EMAIL_ACCOUNT ne "" ) {

  if ( server_reachable( "$REPORT_EMAIL_SERVER", 25 ) ) {

    getopts("s:f:",\%options);

    chomp ( my $who_am_i = `hostname` );

    my $subject;
    if ( defined $options{'s'} ) {
      $subject = $options{'s'} . " ($who_am_i)";
    } else {
      $subject = "Email from $who_am_i";
    }

    my $mail_command = "/usr/bin/mail -s \"$subject\" $REPORT_EMAIL_ACCOUNT\@$REPORT_EMAIL_SERVER";

    my $filename;
    if ( defined $options{'f'} and -f $options{'f'} ) {
      $filename = $options{'f'};
      $mail_command = "/usr/bin/uuencode $filename $filename | $mail_command";
    }

	if ( ! defined $ARGV[0] ) {
      die "ERROR $0 - I need some text or a filename to email";
    }

    my $filename = $ARGV[0];

    wait_for_network();
    system "$mail_command";

  }
} else {
  die "ERROR $0 - The variables REPORT_EMAIL_SERVER and REPORT_EMAIL_SERVER are not defined.";
}


exit 0;
