#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/etc/entman/conf/";
require "entman_config.pl";

################################################################################
# entman - modules
#
#
################################################################################

$kernel_panic_log_file = "/Library/Logs/panic.log";

################################################################################
# Email kernel panic log file if it exists
if ( -e $kernel_panic_log_file ) {

  $timeStamp = getTimeStamp ( ( stat $kernel_panic_log_file )[9] );
  $timeStamp =~ s/ /_/g;

  my $new_panic_filename = "/Library/Logs/panic_${timeStamp}.log";
  system "/bin/mv $kernel_panic_log_file $new_panic_filename";
  
  $new_panic_filename panic_${timeStamp}.log
  
  


  $encode_command = "/usr/bin/uuencode $new_panic_filename panic_${timeStamp}.log";



      $mail_command = "/usr/bin/mail -s \"Panic log from $who_am_i\" $panic_log_mail_account\@$panic_log_mail_server";
      wait_for_network();
      system "$encode_command | $mail_command";
      entman_logger ( "log", "I kernel panicked." );
      system "\"$remote_logger_script\" PANIC \"I kernel panicked\"";
    } else {
      entman_logger ( "log", "There is a panic log, but the email server is unreachable." );
    }
  }
}

exit 0;
