#!/usr/bin/perl

die "Run me as root.\n" if $> ne 0;

use Getopt::Std;

####################################
# Get ARGs
#
getopts("i:d:r:s:",\%options);

my $new_ip = "";
if (defined $options{'i'}) {
  $new_ip = $options{'i'};
}

my $subnet_mask = "255.255.255.0";
if (defined $options{'s'}) {
  $subnet_mask = $options{'s'};
}

my $router = "";
if (defined $options{'r'}) {
  $router = $options{'r'};
}

my $dns_servers = "";
my @dns_server_list = ();
if (defined $options{'d'}) {
  $dns_servers = $options{'d'};
  @dns_server_list = split (' ', $dns_servers);
}

$ncutil="/usr/sbin/ncutil";

if ( defined $options{'i'} ) {
  print "\"$ncutil\" setprop \"/Automatic/Built-in Ethernet/IPv4\" ip-address \"$new_ip\"\n";
  system "\"$ncutil\" setprop \"/Automatic/Built-in Ethernet/IPv4\" ip-address \"$new_ip\"";
}

if ( defined $options{'s'} ) {
  print "\"$ncutil\" setprop \"/Automatic/Built-in Ethernet/IPv4\" subnet-mask \"$subnet_mask\"\n";
  system "\"$ncutil\" setprop \"/Automatic/Built-in Ethernet/IPv4\" subnet-mask \"$subnet_mask\"";
}

if ( defined $options{'r'} ) {
  print "\"$ncutil\" setprop \"/Automatic/Built-in Ethernet/IPv4\" router \"$router\"\n";
  system "\"$ncutil\" setprop \"/Automatic/Built-in Ethernet/IPv4\" router \"$router\"";
}

# Set DNS
foreach $dns_server (@dns_server_list) {
  print "\"$ncutil\" setprop \"/Automatic/Built-in Ethernet/DNS\" name-server $dns_server\n";
  system "\"$ncutil\" setprop \"/Automatic/Built-in Ethernet/DNS\" name-server $dns_server";
}

# Turn it on
print "\"$ncutil\" --apply-on-exit setprop \"/Automatic/Built-in Ethernet/IPv4\" method Manual\n";
system "\"$ncutil\" --apply-on-exit setprop \"/Automatic/Built-in Ethernet/IPv4\" method Manual";
