/*
 * NSView subclass, necessary to get mouseMoved events
 */

#import "SPView.h"

@implementation SPView

/* can't get mouseMoved unless view is first responder */
- ( BOOL )acceptsFirstResponder
{
    return( YES );
}

/*
 * when we're told to become first responder, make the
 * window accept mouseMoved events
 */ 
- ( BOOL )becomeFirstResponder
{
    [[ self window ] setAcceptsMouseMovedEvents: YES ];
    return( YES );
}

/* not necessary for this application, but for balance.... */
- ( BOOL )resignFirstResponder
{
    [[ self window ] setAcceptsMouseMovedEvents: NO ];
    return( YES );
}

- (void)drawRect:(NSRect)rect {
	[[NSColor blackColor] set];
	[[NSBezierPath bezierPathWithRect:rect] fill];
	//NSRectFill([self bounds]);
}

@end
